/*
 * Pomocni program za ucitavanje modula u kernel i kreiranje
 * fajla /dev/telegraf preko kojeg se komunicira sa modulom.
 */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define DEVNAME "telegraf"
#define MODNAME "pc_speaker_telegraf.ko"

int main(int argc, char **argv)
{
	/* 
	 * prvo pozivamo:
	 * 
	 * 		insmod pc_speaker_telegraf.ko
	 * 
	 * da ucitamo modul
	 */
	char *komanda=malloc(strlen("insmod")+strlen(MODNAME)+1);
	strcat(komanda, "insmod ");
	strcat(komanda, MODNAME);
	system(komanda);
	free(komanda);
	
	/*
	 * Zatim u fajlu /proc/devices trazimo pod kojim ID-jem
	 * je registrovan uredjaj zvani 'telegraf'
	 */
	char *fdevnum=malloc(50);
	char *fdevname=malloc(50);
	FILE *proc_devices=fopen("/proc/devices", "r");
	fscanf (proc_devices, "%s %s", fdevnum, fdevname);
	while (fscanf(proc_devices, "%s %s", fdevnum, fdevname)==2)
	{
		if (strcmp(fdevname, DEVNAME)==0)
		{
			/*
			 * Kad nadjemo ID uredjaja, pozivamo komandu da kreiramo
			 * sam fajl uredjaja:
			 * 
			 * 		mknod /dev/telegraf c nadjeni_id_uredjaja 0
			 * 			 
			 */ 
			char *komanda=malloc(strlen(fdevname)+strlen(fdevnum)+strlen("mknod /dev/ c 0")+10);
			strcpy(komanda, "mknod /dev/");
			strcat(komanda, DEVNAME);
			strcat(komanda, " c ");
			strcat(komanda, fdevnum);
			strcat(komanda, " 0");
			system(komanda);
			fclose(proc_devices);
			return 0;
		}
	}
	fclose(proc_devices);
	return 1;
}

