/*
 * Usluzni program za slanje ioctl poziva modulu
 * Prima ID komande i njen parametar, ne vrsi se nikakva provera
 * Na std izlaz se pise povratni rezultat ioctl poziva
 * 
 * Dostupne komande za modul su:
 * 		1 - promena frekvencije zvuka (parametar je frekvencija u Hz)
 * 		3 - promena trajanja tacke po Morzeovoj azbuci (parametar je
 * 			period tacke u milisekundama)
 */
#include <sys/ioctl.h>
#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>


int main(void)
{
	int f=open("/dev/telegraf", O_RDWR);
	unsigned int command;
	unsigned long param;
	scanf("%u", &command);
	scanf("%lu", &param);
	printf("%d\n", ioctl(f, command, param));
}
